#include<stdio.h>
#include<string.h>
#include<stdlib.h>

#include<strings.h>
#include<lists.h>
#include<dbllist.h>

#include"wp2latex.h"
#ifdef __BORLANDC__
 #include "cp_lib/cptran.h"
#else
 #include "cptran.h"
#endif
#include "cp_lib/html.trn"

list HTMLChars(Table_html,sizeof(Table_html)/sizeof(char *));

#define HTMLVersion "0.11"

class TconvertedPass1_HTML:public TconvertedPass1
     {
public:CpTranslator *ConvertHTML;
     CpTranslator *ConvertTXT;
     string TAG;
     doublelist TAG_Args;
     BYTE TablePos;
     };

static void ProcessKeyHTML(TconvertedPass1_HTML *cq);

/*Register translators here*/
void Convert_pass1_HTML(FILE *FileIn,FILE  *table, FILE *StripOut,FILE *LogFile,FILE *ErrorFile);
FFormatTranslator FormatHTML("HTML",Convert_pass1_HTML);


//cq->by = 0 (normal char), 1 (extended char &xxx;), 2 (tag <>), 3 (end tag </>), 127 fail
void ReadHTMLTag(TconvertedPass1_HTML *cq)
{
int c;
string Attribute,Value;

erase(cq->TAG_Args);
c=fgetc(cq->wpd);
if(c=='<')
   {
   cq->by=2;
   cq->TAG='<';
   c=fgetc(cq->wpd);
   if(c=='/') cq->by=3;

   while(!feof(cq->wpd))
	{
	if(c=='>') {cq->TAG+=toupper(c);return;}
	if(c==' ' || c== 10 || c== 13)
	    {
	    if(cq->TAG[1]=='!')
		{
		Attribute="!";Value="";
		do {
		   if( (c=fgetc(cq->wpd)) == EOF) return;
                   if(c==0) return;			 //illegal 0 char
		   cq->TAG+=c;		//read all comment
		   } while (c!='>');
		cq->by=4;
		return;
		}
	    cq->TAG+='>';
	    while(!feof(cq->wpd))	// read arg list
		{
		Attribute=Value="";
		do {
		   c=fgetc(cq->wpd);
		   } while (c==' ' || c=='\r' || c=='\n');
		if(c=='>') break;
		while(c!='=' && c!='>')
		   {
		   Attribute+=c;
		   if( (c=fgetc(cq->wpd)) == EOF) return;
                   if(c==0) return;			 //illegal 0 char
		   }
		if(c=='>') break;
		c=fgetc(cq->wpd);
		if(c=='"')
		   {
		   c=fgetc(cq->wpd);
		   while(c!='\"' && c!='>')
		     {
		     Value+=c;
		     if( (c=fgetc(cq->wpd)) == EOF) break;
                     if(c==0) {c='>';break;}			//illegal 0 char
		     }
		   }
		cq->TAG_Args.Add(Attribute(),Value());
		if(c=='>') break;
		}
	    return;
	    }

	cq->TAG+=toupper(c);
	c=fgetc(cq->wpd);
	}

   cq->TAG+='>';			//EOF reached
   return;
   }

if(c=='&')
   {
   cq->by=1;

   cq->TAG=c;
   while(!feof(cq->wpd))
       {
       c=fgetc(cq->wpd);
       if(c==';') break;
       if(isspace(c)==' ' || c==0)  //unterminated & sequence
	   {                   	    //space also terminates &xx; section (CR, LF, TAB and ' ')
	   break;
	   }

       cq->TAG+=c;
       }
   cq->TAG+=';';
   return;
   }

cq->by=0;
cq->subby=c;
cq->TAG=c;
}


/*This function converts comment inside HTML*/
static void CommentHTML(TconvertedPass1_HTML *cq)
{
#ifdef DEBUG
  fprintf(cq->log,"\n#CommentHTML() ");fflush(cq->log);
#endif
  boolean Old_char_on_line;
  unsigned char OldFlag;
  attribute OldAttr;
  int i,maxi,commentchars;


  OldFlag = cq->flag;
  OldAttr = cq->attr;
  Old_char_on_line = cq->char_on_line;
  cq->flag = CharsOnly;
  cq->recursion++;
  InitAttr(cq->attr);		//Turn all attributes in the comment off


  fputc('%',cq->strip);

  maxi=length(cq->TAG);
  i=0;
  commentchars=0;
  if(cq->TAG[i]=='<' && cq->TAG[i+1]=='!' && cq->TAG[maxi-1]=='>') {i+=2;maxi--;}
  if(cq->TAG[i]=='-' && cq->TAG[maxi-1]=='-' && i<maxi) {i++;maxi--;}
  if(cq->TAG[i]=='-' && cq->TAG[maxi-1]=='-' && i<maxi) {i++;maxi--;}
  while(cq->TAG[i]==' ' && cq->TAG[maxi-1]==' ' && i<maxi) {i++;maxi--;}

  while (i<maxi)
       {
       cq->by=cq->TAG[i++];
       if(cq->by==0) break;

       if(cq->by==0xA || cq->by==0xD)	//New comment line
		{
		if(commentchars)
		  {
		  cq->line_term = 's';    	//Soft return
		  Make_tableentry_envir_extra_end(cq);
		  fprintf(cq->strip, "\n");
		  cq->rownum++;
		  Make_tableentry_attr(cq);

		  fputc('%',cq->strip);
		  commentchars=0;
		  }
		continue;
		}

       fputc(cq->by,cq->strip);
       commentchars++;
       continue;
       }

  cq->line_term = 's';    	//Soft return
  Make_tableentry_envir_extra_end(cq);
  fprintf(cq->strip, "\n");
  cq->rownum++;
  Make_tableentry_attr(cq);


  cq->recursion--;
  strcpy(cq->ObjType, "Comment");
  cq->attr = OldAttr;
  cq->flag = OldFlag;
  cq->char_on_line = Old_char_on_line;
  cq->char_on_line = true;
}


#define PaperSize  210.0
#define PagePixels 800.0
static void ImageHTML(TconvertedPass1_HTML *cq)
{
#ifdef DEBUG
  fprintf(cq->log,"\n#IndentHTML() ");fflush(cq->log);
#endif
TBox Box;
int i;
char *FileName=NULL;
char *str,terminator;

  Box.Width=100; 		//100mm
  Box.Image_type=0;		//Image on disk
  Box.AnchorType = 0; 		/*0-Paragraph, 1-Page, 2-Character*/
  Box.HorizontalPos=2;		/*0-Left, 1-Right, 2-Center, 3-Full */
  Box.Image_size=0;
  if((i=cq->TAG_Args IN "src")>=0 || (i=cq->TAG_Args IN "SRC")>=0)
	FileName=cq->TAG_Args.Member(i,1);
  if((i=cq->TAG_Args IN "width")>=0 || (i=cq->TAG_Args IN "WIDTH")>=0)
	{
	str=cq->TAG_Args.Member(i,1);
	switch(sscanf(str,"%f%c",&Box.Width,&terminator))
	  {
	  case 0:terminator=255;break;
	  case 1:terminator=0;break;
	  case 2:break;
	  default:terminator=255;break;
	  }
	switch(terminator)
	  {
	  case 0:Box.Width*=PaperSize/PagePixels;
		 break;					//normal
	  case '%':Box.HorizontalPos=4;
		 if(Box.Width==100) Box.HorizontalPos=3;
		 break;				        //percentage
	  default:break;			        //nothing
	  }
	}
  if(FileName==NULL) FileName="dummy";;

  ImageWP(cq, FileName, Box, NULL);
return;
}


static void IndentHTML(TconvertedPass1_HTML *cq)
{
#ifdef DEBUG
  fprintf(cq->log,"\n#IndentHTML() ");fflush(cq->log);
#endif
  cq->tabpos[0]=470+cq->WP_sidemargin;
  Indent(cq,0);
}


static void ItemizeHTML(TconvertedPass1_HTML *cq)
{
#ifdef DEBUG
  fprintf(cq->log,"\n#ItemizeHTML() ");fflush(cq->log);
#endif
unsigned char OldFlag;
char OldEnvir;
long FilePos;
int i,FieldCount=0;
char State=0;
char *Align;
char *FieldPos=NULL,Alignment;

  FilePos = ftell(cq->wpd);
  OldFlag = cq->flag;
  OldEnvir = cq->envir;
  cq->flag = Nothing;
  cq->recursion++;

  cq->line_term = 's';   /* Soft return */
  if(cq->char_on_line == -20)    /* Left one enpty line for new enviroment */
	{
	fputc('%', cq->table);fputc('%', cq->strip);
	NewLine(cq);
	}
  if(cq->char_on_line>=true) //  if(cq->char_on_line>=-1)
	{
	NewLine(cq);
	}
  cq->envir='!';
  fputc('%', cq->table);fputc('%', cq->strip);
  NewLine(cq);

  cq->envir = ' ';

  fprintf(cq->strip, "\\begin{itemize}");

  cq->char_on_line = false;
  cq->nomore_valid_tabs = false;
  cq->rownum++;
  Make_tableentry_attr(cq);
  cq->latex_tabpos = 0;

	/*Process all content of the table */
  cq->flag=OldFlag;
  fseek(cq->wpd,FilePos,SEEK_SET);
  ReadHTMLTag(cq);
  while(!feof(cq->wpd))
	{
/*	if(cq->by==0 && (cq->subby==10 || cq->subby==13))
		{
		cq->subby=' ';	// remove \n from cell text
		} */
	ProcessKeyHTML(cq);
	if(cq->by==144)
		{
		if(cq->subby==1) break; /*End of itemize*/
		if(cq->subby==2) fprintf(cq->strip, "\\item ");
		}

	ReadHTMLTag(cq);
	}

  fprintf(cq->strip, "\\end{itemize}");
  if(cq->char_on_line <= -10)    /* Left one enpty line for ending enviroment */
	{
	fputc('%', cq->table);fputc('%', cq->strip);
	NewLine(cq);
	}
  cq->envir='^';		//Ignore enviroments after table
  fputc('%', cq->table);
  NewLine(cq);
  cq->char_on_line = -10;		// stronger false;

  cq->recursion--;

  cq->flag=OldFlag;
  cq->envir=OldEnvir;
cq->TAG="ITEMIZE";
strcpy(cq->ObjType, "Table Start");
}


/*This function extracts some information from meta HTML tag*/
static void MetaHTML(TconvertedPass1_HTML *cq)
{
#ifdef DEBUG
  fprintf(cq->log,"\n#MetaHTML() ");fflush(cq->log);
#endif
  int i;
  char *content,*charset;
  string translator;

  strcpy(cq->ObjType, "Meta");

  if((i=cq->TAG_Args IN "content")>=0 || (i=cq->TAG_Args IN "CONTENT")>=0)
	{
	content=cq->TAG_Args.Member(i,1);
	if(content==NULL) return;
	charset=strstr(content,"CHARSET");
	if(charset==NULL) charset=strstr(content,"charset");
	if(charset==NULL) return;
	charset+=7;
	while(*charset==' ') charset++;
	if(*charset++!='=') return;
	while(*charset==' ') charset++;

	if(!strcmp(charset,"iso-8859-1")) translator="iso_8859_1";
	else if(!strcmp(charset,"iso-8859-2")) translator="iso_8859_2";
	else if(!strcmp(charset,"windows-1250")) translator="cp1250";
	else if(!strcmp(charset,"windows-1251")) translator="cp1251";
	else if(!strcmp(charset,"windows-1252")) translator="cp1252";
	else translator=charset;
	translator+="TOwp5";
	cq->ConvertTXT = GetTranslator(translator);
	}
}


static void ScriptHTML(TconvertedPass1_HTML *cq)
{
#ifdef DEBUG
  fprintf(cq->log,"\n#ScriptHTML() ");fflush(cq->log);
#endif
unsigned char OldFlag;

OldFlag = cq->flag;
cq->flag = Nothing;

do {
   cq->TAG = "";
   ProcessKeyHTML(cq);
   if(cq->by==138 && cq->subby==1) break;
   }while(!feof(cq->wpd));

cq->flag = OldFlag;
}


static void TableHTML(TconvertedPass1_HTML *cq)
{
#ifdef DEBUG
  fprintf(cq->log,"\n#TableHTML() ");fflush(cq->log);
#endif
unsigned char OldFlag;
char OldEnvir;
long FilePos;
int i,FieldCount=0;
char State=0;
char *Align;
char *FieldPos=NULL,Alignment;

FilePos = ftell(cq->wpd);
OldFlag = cq->flag;
OldEnvir = cq->envir;
cq->flag = Nothing;
cq->recursion++;

do {
   cq->TAG = "";
   ProcessKeyHTML(cq);
   if(cq->by==143)
     {
     if(cq->subby == 0) break;			// <TABLE>
     if(cq->subby == 1) break;			// </TABLE>
     if(cq->subby == 2)				// <TR>
	  {
	  if(State==0) {State++;continue;}
	  if(FieldCount==0) continue;
	  break;
	  }
     if(cq->subby == 3) break;			// </TR>
     if(cq->subby == 4 || cq->subby == 6)	// <TD> or <TH>
	  {
	  if(State==0) State++;
	  Alignment='l';
	  if((i=cq->TAG_Args IN "align")>=0 || (i=cq->TAG_Args IN "ALIGN")>=0)
	      {
	      Align=cq->TAG_Args.Member(i,1);
	      if(!StrCmp(Align,"left"))  Alignment='l';
	      if(!StrCmp(Align,"right")) Alignment='r';
	      if(!StrCmp(Align,"center"))Alignment='c';
	      }
	  if(FieldPos==NULL) FieldPos=(char *)malloc(100);
	  if(FieldCount<100 && FieldPos!=NULL)
		{
		FieldPos[FieldCount]=Alignment;
		}
	  FieldCount++;
	  }
     }
   }while(!feof(cq->wpd));


  if(FieldCount>0)
    {
    cq->line_term = 's';   /* Soft return */
    if(cq->char_on_line == -20)    /* Left one enpty line for new enviroment */
	{
	fputc('%', cq->table);fputc('%', cq->strip);
	NewLine(cq);
	}
    if(cq->char_on_line>=true) //  if(cq->char_on_line>=-1)
	{
	NewLine(cq);
	}
    cq->envir='!';
    fputc('%', cq->table);fputc('%', cq->strip);
    NewLine(cq);

    cq->envir = 'B';

    fprintf(cq->strip, "{|");
    for (i = 0; i < FieldCount; i++)
	{
	Alignment='l';
	if(FieldCount<100 && FieldPos!=NULL) Alignment=FieldPos[i];
	fprintf(cq->strip, "%c|",Alignment);
	}
    putc('}', cq->strip);

    cq->char_on_line = false;
    cq->nomore_valid_tabs = false;
    cq->rownum++;
    Make_tableentry_attr(cq);
    cq->latex_tabpos = 0;
    }

	/*Process all content of the table */
  cq->flag=OldFlag;
  fseek(cq->wpd,FilePos,SEEK_SET);
  ReadHTMLTag(cq);
  while(!feof(cq->wpd))
	{
	if(cq->by==0 && (cq->subby==10 || cq->subby==13))
		{
		cq->subby=' ';	/* remove \n from cell text */
		}
	ProcessKeyHTML(cq);
	if(cq->by==143 && cq->subby==1) break; /*End of table*/

	ReadHTMLTag(cq);
	}
  if(cq->char_on_line <= -10)    /* Left one enpty line for ending enviroment */
	{
	fputc('%', cq->table);fputc('%', cq->strip);
	NewLine(cq);
	}
  cq->envir='^';		//Ignore enviroments after table
  fputc('%', cq->table);
  NewLine(cq);
  cq->char_on_line = -10;		// stronger false;

  cq->recursion--;

  cq->flag=OldFlag;
  cq->envir=OldEnvir;
cq->TAG="TABLE";
strcpy(cq->ObjType, "Table Start");
}


static void ProcessKeyHTML(TconvertedPass1_HTML *cq)
{
#ifdef DEBUG
  fprintf(cq->log,"\n#ProcessKeyHTML() ");fflush(cq->log);
#endif
 string TAG;
 char *tag;
 BYTE by,subby;
 WORD WChar;
 int i;

 *cq->ObjType=0;
 if(cq->TAG=="") ReadHTMLTag(cq);
 by=cq->by;
 subby=cq->subby;

 switch(by)
	{
	case 0:switch(cq->subby)
		  {
		  case 10:
		  case 13:by=128;break; //CR
		  case  9:strcpy(cq->ObjType, "!Tab");
		  case 32:by=32;break;  //Space
		  }
	       break;					//Normal character
	case 1:TAG=copy(cq->TAG,1,length(cq->TAG)-2);   //Extended chatacter &xxx;
	       if( (tag=TAG())==NULL) break;
	       if(TAG=="nbsp")	{by=200;break;}  	//Hard space

	       if((i=(TAG() IN HTMLChars))>0)
		  {
		  i--;
		  if(cq->ConvertHTML!=NULL)	/*Translate HTML character set to WP5.x one*/
		     {
		     i=(*cq->ConvertHTML)[i];
		     }

		  by=201;
		  tag=Ext_chr_str(i / 256,i % 256,cq);
		  }
//	       else
//		  asm int 3;

//	       fprintf(cq->strip," !!!&%s; ",TAG.ch);
	       break;
	case 2:TAG=copy(cq->TAG,1,length(cq->TAG)-2);	//Normal tag <xxx>
	       if( (tag=TAG())==NULL) break;
	       if(TAG=="B")    {by=129;subby=12;break;}   //ATTR on bold
	       if(TAG=="BIG")  {by=129;subby=2;break;}    //ATTR on large
	       if(TAG=="BR")   {by=131;break;} 	   	  //HRt
	       if(TAG=="DD")   {by=140;break;} 	   	  //Indented definition
	       if(TAG=="CENTER"){by=134;subby=0x82;break;}//Justification Center
	       if(TAG=="H1")   {by=135;subby=1;break;}    //section level 1
	       if(TAG=="H2")   {by=135;subby=2;break;}    //section level 2
	       if(TAG=="H3")   {by=135;subby=3;break;}    //section level 3
	       if(TAG=="H4")   {by=135;subby=4;break;}    //section level 4
	       if(TAG=="H5")   {by=135;subby=1;break;}    //section level 5
	       if(TAG=="H6")   {by=135;subby=2;break;}    //section level 6
	       if(TAG=="HR")   {by=139;subby=0;break;}    //horizontal line
	       if(TAG=="I")    {by=129;subby=8;break;}    //ATTR on italic
	       if(TAG=="IMG")  {by=142;break;}		  //Image
	       if(TAG=="LI")   {by=144;subby=2;break;}    //Start of item
	       if(TAG=="META") {by=137;subby=0;break;}    //meta tag
	       if(TAG=="P")    {by=132;break;} 	   //new paragraph
	       if(TAG=="S")    {by=129;subby=13;break;}   //ATTR on strike out
	       if(TAG=="SMALL"){by=129;subby=3;break;}    //ATTR on small
	       if(TAG=="SCRIPT"){by=138;subby=0;break;}    //start SCRIPT
	       if(TAG=="SUB")  {by=129;subby=6;break;}    //ATTR on subscript
	       if(TAG=="SUP")  {by=129;subby=5;break;}    //ATTR on superscript
	       if(TAG=="TABLE"){by=143;subby=0;break;}    //Start of the table
	       if(TAG=="TD")   {by=143;subby=4;break;}    //Start of cell
	       if(TAG=="TH")   {by=143;subby=6;break;}    //Start of head cell
	       if(TAG=="TR")   {by=143;subby=2;break;}    //Start of row
	       if(TAG=="TT")   {by=129;subby=16;break;}	  //ATTR on typewriter
	       if(TAG=="U")    {by=129;subby=14;break;}   //ATTR on underline
	       if(TAG=="UL")   {by=144;subby=0;break;}    //Start of itemize
	       break;
	case 3:TAG=copy(cq->TAG,2,length(cq->TAG)-3);	//Closing tag </xxx>
	       if( (tag=TAG())==NULL) break;
	       if(TAG=="B")    {by=130;subby=12;break;}  //ATTR off bold
	       if(TAG=="BIG")  {by=130;subby=2;break;}   //ATTR off large
	       if(TAG=="CENTER"){by=134;subby=0x81;break;} //End of center justification
	       if(TAG=="DD")   {by=141;break;} 	   	  //End of indented definition
	       if(TAG=="DL")   {by=141;break;} 	   	  //End of definition list
	       if(TAG=="H1")   {by=136;subby=1;break;}    //section off level 1
	       if(TAG=="H2")   {by=136;subby=2;break;}    //section off level 2
	       if(TAG=="H3")   {by=136;subby=3;break;}    //section off level 3
	       if(TAG=="H4")   {by=136;subby=4;break;}    //section off level 4
	       if(TAG=="H5")   {by=136;subby=1;break;}    //section off level 5
	       if(TAG=="H6")   {by=136;subby=2;break;}    //section off level 6
	       if(TAG=="LI")   {by=144;subby=3;break;}    //End of item
	       if(TAG=="I")    {by=130;subby=8;break;}    //ATTR off italic
	       if(TAG=="P")    {by=133;break;} 		  //end paragraph
	       if(TAG=="S")    {by=130;subby=13;break;}	  //ATTR off strike out
	       if(TAG=="SMALL"){by=130;subby=3;break;}    //ATTR off small
	       if(TAG=="SCRIPT"){by=138;subby=1;break;}   //end SCRIPT
	       if(TAG=="SUB")  {by=130;subby=6;break;}    //ATTR off subscript
	       if(TAG=="SUP")  {by=130;subby=5;break;}    //ATTR off superscript
	       if(TAG=="TABLE"){by=143;subby=1;break;}    //End of Table
	       if(TAG=="TD")   {by=143;subby=5;break;}	  //End of cell
	       if(TAG=="TH")   {by=143;subby=7;break;}    //End of head cell
	       if(TAG=="TR")   {by=143;subby=3;break;}    //End of row
	       if(TAG=="TT")   {by=130;subby=16;break;}	  //ATTR off typewriter
	       if(TAG=="U")    {by=130;subby=14;break;}   //ATTR off underline
	       if(TAG=="UL")   {by=144;subby=1;break;}    //End of itemize
	       break;
	case 4:				//comment
	       break;
	}

  cq->by=by;
  cq->subby=subby;
  if(cq->flag<Nothing)
    switch(by)
	{
	case 0:WChar=0;
	       if(cq->ConvertTXT) WChar=(*cq->ConvertTXT)[subby];
	       if(WChar) tag=Ext_chr_str(WChar/256,WChar%256,cq);
		    else tag=Ext_chr_str(0,subby,cq);
	       CharacterStr(cq,tag);
	       break;		//Normal character
	case 4:CommentHTML(cq);
	       break;
	case 32:putc(' ', cq->strip);   /*soft space*/
		break;

	case 128:if(cq->TablePos!=1 && cq->TablePos!=3)
		   if(cq->char_on_line)
			SoftReturn(cq);
		 break;
	case 129:AttrOn(cq->attr,subby);break;
	case 130:AttrOff(cq,subby);     break;
	case 131:HardReturn(cq);        break;
	case 132:if(cq->char_on_line) HardReturn(cq);  //Paragraph on
		 SoftReturn(cq);
		 break;
	case 133:if(cq->char_on_line) HardReturn(cq);  //Paragraph off
		 break;
	case 134:Justification(cq,subby);break;
	case 135:StartSection(cq,-subby);break;
	case 136:EndSection(cq,-subby);	break;
	case 137:MetaHTML(cq);break;
	case 138:ScriptHTML(cq);	break;
	case 139:HLine(cq,-16);		break;
	case 140:IndentHTML(cq);	break;
	case 141:End_of_indent(cq);	break;
	case 142:ImageHTML(cq);		break;
	case 143:switch(subby)
		   {
		   case 0:TableHTML(cq);cq->TablePos=1;break;
		   case 1:EndTable(cq);cq->TablePos=0; break;
		   case 2:RowTable(cq);cq->TablePos|=2;break;
		   case 3:cq->TablePos&=~2;break;
		   case 4:
		   case 6:CellTable(cq);cq->TablePos|=4;break;
		   case 5:
		   case 7:cq->TablePos&=~4;break;
		   }
		 break;
	case 144:switch(subby)
		   {
		   case 0:ItemizeHTML(cq);break;
		   }
		 break;

	case 200:fputc('~', cq->strip);strcpy(cq->ObjType, " ");
		 break;
	case 201:CharacterStr(cq,tag);break; //
	}


 cq->by=by;
 cq->subby=subby;
 if (cq->log != NULL)
    {   /**/
    if(by==128) fputc('\n',cq->log);
    else if(by==' ' || by==200) fputc(' ',cq->log);
    else if(by==0 || by==201)
	{
	fprintf(cq->log,"%s",tag);
	}
    else
	{
	fprintf(cq->log, _("\n%*s [%s %s]   "),
		  cq->recursion * 2, "", cq->TAG(), cq->ObjType);
//	if(*cq->ObjType==0) UnknownObjects++;
	}
    }

 cq->ActualPos = ftell(cq->wpd);
}


void Convert_pass1_HTML(FILE *FileIn,FILE  *table, FILE *StripOut,FILE *LogFile,FILE *ErrorFile)
{
#ifdef DEBUG
  fprintf(LogFile,"\n#Convert_pass1_HTML() ");fflush(LogFile);
#endif
  DWORD fsize;
  TconvertedPass1_HTML cq;


   if(Verbosing >= 1)
     printf(_("\n>>>HTML2LaTeX<<< Conversion program: From HTML to LaTeX Version %s\n"
	      "      Made by J.Fojtik  (Hosted on WP2LaTeX :))))\n\n"),
	    HTMLVersion);

  Table_Init(lat);

  InitAttr(cq.attr);
  cq.ConvertHTML = GetTranslator("htmlTOwp5");
  cq.ConvertTXT = NULL;

  cq.wpd   = FileIn;
  cq.table = table;
  cq.strip = StripOut;
  cq.log   = LogFile;
  cq.err   = ErrorFile;

  WP_Default(&cq);


  cq.DocumentStart=ftell(cq.wpd);

  cq.envir = ' ';
  cq.TablePos=0;

  cq.nomore_valid_tabs = false;


  fsize=filesize(cq.wpd);
  cq.perc.Init(ftell(cq.wpd), fsize,_("First pass HTML:\n") );

  cq.rownum = 0;

  Make_tableentry_attr(&cq);    /* attribuut instelling */
  Make_tableentry_tabset(&cq);  /* Geef the defaulttabinstelling door */
				/* tied the 2e pass */

  cq.ActualPos = ftell(cq.wpd);
  while (cq.ActualPos < fsize)
      {
      if(Verbosing >= 1)		//actualise a procentage counter
	      cq.perc.Actualise(cq.ActualPos);

      cq.TAG = "";
      ProcessKeyHTML(&cq);
      }
  Close_All_Attr(cq.attr,cq.strip);


  cq.line_term = 's';			   /* Soft return */
  Make_tableentry_envir_extra_end(&cq);
  if(cq.CentrePage)    /* finish page centering */
	{
	fprintf(cq.strip, "\\vfil ");
	cq.CentrePage=false;
	}

  num_of_lines_stripfile = cq.rownum;

  if(Verbosing >= 1)		//finishing a procentage counter
     {
     cq.perc.SetPercent(100);
     putchar('\n');
     }
}
